{% extends 'base.html.twig' %}
{% block title %} Placement Pixel Art {{pixelArt.id}}{% endblock %}

{% block body %}
    <div class="container">
        <div class="row align-items-center">
            <div class="card">
                <h1>Choissisez ou votre Pixel Art apparaitra</h1>
                <div class="row">
                    <div class="col-md-6">
                        <img id="bannerImg" class="" src="{{ path('banner-img', {'banner' : pixelArt.banner.id}) }}"
                                alt="">
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <img id="pixelArtImg" src="{{ path('pixel_art_image', {'pixelPub': pixelArt.id}) }}" alt=""
                            width="{{ pixelArt.width }}px" title="{{ pixelArt.title }}">
                </div>
            </div>
            <form action="{{ path('pixel_art_place_save', {'pixelArt' : pixelArt.id}) }}">
                <input type="hidden" id="coordX" name="coordX">
                <input type="hidden" id="coordY" name="coordY">
                <button class="btn btn-outline-dark" type="submit">Sauvegarder</button>

            </form>
        </div>
    </div>
{% endblock %}

{% block javascripts %}
<script>
    function testChevauchement (x , y) {
        // remplir un un tableau avec les dimensions et coordonées de chaque pixel art de la banniere
        const aPixelArtsCoords = []
        {% for pA in pixelArt.banner.pixelPubs %}
            {% if pA.coords is not empty %}
                pACoords = [{{ pA.coords[0] }},{{ pA.coords[1] }}, {{ pA.width }},{{ pA.height }}]
                aPixelArtsCoords.push(pACoords)
            {% endif %}
        {% endfor %}
        // parcourir chaque pixel art verifier la coords de chacun
        test = true
        aPixelArtsCoords.forEach( element  => {
            let x1Click = x
            let y1Click = y
            let x2Click = (x + {{pixelArt.width}})
            let y2Click = (y + {{pixelArt.height}})
            let x1Pa = element[0]
            let y1Pa = element[1]
            let x2Pa = element[0]+element[2]
            let y2Pa = element[1]+element[3]
            let bannerWidth = {{pixelArt.banner.width}}
            let bannerHeight = {{pixelArt.banner.height}}

            if( (test !== false) &&
                //Test des quatres coins en cas de chevauchement
                (
                    ((x1Click < x1Pa)  || (x1Click > x2Pa)) ||
                    ((y1Click < y1Pa)  || (y1Click >= y2Pa))
                ) &&
                (
                    (((x2Click-1) <= x1Pa)  || (x2Click > x2Pa)) ||
                    ((y2Click < y1Pa)  || (y2Click > y2Pa))
                ) &&
                (
                    (((x2Click-1) <= x1Pa)  || (x2Click > x2Pa)) ||
                    ((y1Click < y1Pa)  || (y1Click >= y2Pa))
                ) &&
                (
                    ((x1Click < x1Pa)  || (x1Click > x2Pa)) ||
                    ((y2Click < y1Pa)  || (y2Click > y2Pa))
                ) &&
                (
                    (x2Click < bannerWidth ) && (y2Click < bannerHeight )
                )
            ){
                test = true
            }else {
                test = false
            }
        })
        return test
    }
    let x = 0
    let y = 0
    let pageX = 0
    let pageY = 0
    document.addEventListener('keydown' , event => {

        let newX = x
        let newY = y
        let newPageX = pageX
        let newPageY = pageY
        switch(event.key) {
            case 'ArrowUp' :
                event.preventDefault()
                newY = newY-1
                newPageY = newPageY-1
                break
            case 'ArrowDown' :
                event.preventDefault()
                newY = newY+1
                newPageY = newPageY+1
                break
            case 'ArrowLeft' :
                event.preventDefault()
                newX = newX-1
                newPageX = newPageX-1
                break
            case 'ArrowRight' :
                event.preventDefault()
                newX = newX+1
                newPageX = newPageX+1
                break
            default : return
        }
        if (
            (newX > 0) && (newY > 0) &&
            (newX < {{pixelArt.banner.width}}) && (newY < {{pixelArt.banner.height}}) &&
            (testChevauchement( newX , newY))
        ){
            x = newX
            y = newY
            pageX = newPageX
            pageY = newPageY
            document.getElementById("coordX").value = x
            document.getElementById("coordY").value = y
            {# TODO commentaire #}
            const pixelArt = document.getElementById('pixelArtImg')
            pixelArt.style.top = pageY +"px"
            pixelArt.style.left = pageX +"px"
            pixelArt.style.display = 'inline'
        }
    })
    document.getElementById('bannerImg').addEventListener( 'click' , event => {
        // tester si on ne chevaiche aps un pixel art deja en place
        // besoin des pixel art coords deja en place
        if ( testChevauchement( event.offsetX ,event.offsetY) )
        {
            document.getElementById("coordX").value = event.offsetX
            document.getElementById("coordY").value = event.offsetY
            const pixelArt = document.getElementById('pixelArtImg')
            pixelArt.style.top = event.pageY +"px"
            pixelArt.style.left = event.pageX+"px"
            pixelArt.style.display = 'inline'
            x = event.offsetX
            y = event.offsetY
            pageX = event.pageX
            pageY = event.pageY
        }
    })
</script>
{% endblock %}
